/*
Update log:

--07 JULY 2013
Wow, its been a year.  Well, a good time to do some fixes.

I updated how some things work, more specifically the order things work in.
Its just some small changes.
- Made mob's turn_ended() be called before the check to see if the battle was over.
	The reason for this is that mob.turn_ended() calls mob.action() which should be overridden
	to do whatever you want to do directly after the mob chooses their action.  The way it was before,
	if you chose to run, you would not actually run until the next person's turn started/ended because of the
	order things were called.

- Updated the demo.dm to no longer just give you a little box of hud options that prevents you from moving.
	I put this hud into the battle demo.  It's not some aesthetically pleasing piece, but it proves how easy
	the hud can be added.

- Added update_selections() to the battle_hud datum.  This was basically just a proc I made to put code
	I already had in the datum into.  This allows for more flexibility in being able to change what the
	hud has for you to select, rather than having to constantly delete it and make a new one.  May not be
	used much, but it is versatility.

- Added variables highlight_color and default_color to battle_hud datum.  This was specifically added to make my
	addition of update_selections() work.  Again, more versatility.  No arguments in the battle datum are changed,
	but the highlight_color argument name was changed to hc, and the default_color argument was changed to dc.

--29 JULY 2012--

Fixed some tiny runtime errors that appeared sometimes.

--28 JULY 2012--

Added HUD support.  Backgrounds are not supported due to both their broadness and ease of use.  Selections are supported, however.
	To customize selections:
		battle_hud
			slots = 4 // slots is how many selections you can see total
			columns = 2 // columns is how many columns selections have.  this is used with the battle_hud's up() down() left() and right() procs.

		Every mob has a battle_hud variable.  To initialize it:
			battle_hud = new(src, list("item1", /skill/skill2))

			All items in the list will be converted to /hud_selection HudObjects.

		Every mob has a battle_hud_selected(hud_selection/s) proc.
			Since every /hud_selection has a skill variable storing the skill it is assigned to, it use()s the skill automatically when selected.
			If it doesn't have a skill and is instead a text value, it will call owner.battle_hud_selected(src).  This is the area where
				you would receive input if someone selected "FIGHT".  So you would delete their battle_hud and reinitialize it with new selections.

		battle_huds have a set_screen_locs() proc that loops through all the selections, finds the column and row they are on, and do this:
			s.screen_loc = get_screen_loc(row, column)
		get_screen_loc(row, column) is the proc you should edit to determine where selections should go.

		Once BYOND allows mouse procedures to work on icons that don't have an icon but rather have maptext, clicking should theoretically work.
			It obviously has not been and cannot be tested right now, so it is very possible there will be bugs if you try to activate the ability
			to click selections before I fix these bugs and update the library.
			If you want to activate clicking however, you need only do this:
				battle_hud
					selection_type = CLICK
			If you want them to be able to click it OR be able to hit a key, simply do this:
				battle_hud
					selection_type = CLICK | KEY
			Remember to set battle_hud/selection_key if you want to have them hit a key other than "return".

		Also note that you can customize the color of the selection's text, both when it is highlighted and when it is not.
			There are 2 more arguments in the battle_hud/New() proc that allow this.
			battle_hud = new(src, list(), highlight_color = "blue", default_color="black")

A few miscellanious fixes.

--15 JULY 2012--

	/map_info now only stores the z level.  new /battle_info/side_one and /battle_info/side_two should be placed on the map where you want them to be located.
		mobs automatically face each other, no need to specify what direction.

	when mobs are located to the new battle map, turn_side's members list is updated to only have those that are in the battle (In case there isn't enough
		/battle_info/side_one or /battle_info/side_two objects on the map).

	added turn_side.battle() and turn_control.battle() - turn_side.battle() returns turn_control.battle(), which returns the /battle's client list.
		intended use of this is for things like battle() << "It happened!"

--14 JULY 2012--
Did quite the overhaul.  Made things a little easier to modify:
	added new global constant variables:
		ALL_INPUT_FIRST
		ACT_IMMEDIATELY
		ALTERNATE_SIDES
	one of these constants is assigned to battle.input_mode in /battle/New() - ACT_IMMEDIATELY by default.

	added mob.my_turn() - is called when the mob's turn starts.  Once it returns a value, their turn will end.

	added mob.turn_ended() - is called when the mob's turn ends.

	added mob.side_turn_ended() - is called when the mob's team's turn ends.  Taking suggestions for a better, easier-to-remember name for this.
		NOTE: This is not called when input_mode is ALTERNATE_SIDES.

	renamed turn_side.enemy() to turn_side.get_enemy() for better clarification and recognizing.

	added turn_control.get_next() - is called when a mob's turn ends, to figure out who goes next.
		By default it checks input_mode - if it is ALTERNATE_SIDES, then it returns the other side's get_next() proc.
		Otherwise, it returns the current_turn's get_next() proc.

	added turn_side.get_next() - is called by turn_control.get_next().  By default returns the next mob in line.

	changed turn_side.can_act() - it is now easier to override.  Instead of returning values, it now changes . to TRUE or FALSE.  FALSE by default.
		Changes to TRUE if it's the mob's turn.
		This means that to modify it you can now easily do:
			turn_side/can_act()
				..()
				// add custom checks here

	removed turn_side.end() - ending turns is now controlled via turn_side.get_next()'s return value.

	added turn_control.next_turn() - this is called once a mob ends it's turn.  turn_control checks if it is alternating, and if so switches to the other side.
		Otherwise it checks current_turn.get_next() - if it is null, call end_turn(current_turn), otherwise set current_turn.current_turn to current_turn.get_next()
		and call current_turn.begin()

	changed how turn_side.begin() is used - it now simply calls turn_started(current_turn).  begin() is called by turn_control.next_turn(), so it is called every time
		a mob from that turn_side.members turn begins.

	changed turn_control.begin() - it now sets both side's current_turn to the first member of their members list, and sets it's own current_turn to the return
		value of turn_control.pick_side()

	added turn_control.pick_side() - this returns side_one by default.  This is what users should override to add the possibility for the enemy to go first, for example.

	re-ordered /battle/New() arguments with the necessary first and optional later.  It is now:
		(id, list/side_one, list/side_two, map_info/m, inp_mode = ACT_IMMEDIATELY, side_limit = 0, list/c, list/all)

	re-ordered battle_control.new_battle() arguments to be as similar to battle.New() as possible.  The new argument order is:
		(party/one, party/two, map_info/map, input_mode = ACT_IMMEDIATELY, side_limit = 0)

	added new battle_control variable map_info/default_map.  users should define their own default map and set this variable to it -
		battle_control.new_battle() sets it's map argument to default_map by default now, meaning that with a default_map defined, you need only call:
			battle_control.new_battle(party_one, party_two)

	added turn_side.input_mode() - simply return's the current battle's input_mode (ACT_IMMEDIATELY, ALL_INPUT_FIRST, ALTERNATE_SIDES)

	added mob.action() - this should execute whatever action they chose during their turn.

	updated mob.turn_ended() and mob.side_turn_ended() - turn_ended() now calls action() if the battle's input_mode is ACT_IMMEDIATELY or ALTERNATE_SIDES
		and side_turn_ended calls action() if the battle's input mode is ALL_INPUT_FIRST.

	added mob.selection variable - this holds a text value of what the mob selected during their turn.

	updated mob.action() - if selection is the name of one of their skills, call skills.use(skill, enemy)

	changed turn_side.get_enemy() to turn_side.get_enemies() - it now returns the members list of the opposing side

	added mob.targets variable list - should be filled with targets that the user is targetting this turn

	added mob.pick_targets(skill/s) - should be called after mob selects a skill.  Fills the mob's targets list.

	added skill.target(list/targets) proc - called by mob.pick_targets() and returns a list that used targets.Copy(1, max_targets+1) by default.

	changed skill.use(mob/target) to skill.use(list/targets) to allow for more than one target

	added battle.reset_members() - this is called in battle.end().  functionality has not changed, it is just organized differently for easier overriding.

	added battle.end_override() - this is a proc called right before the /battle is deleted by default, so users can make something else happen if they wish.
		This proc is called AFTER mobs are relocated and reset - if for some reason they want to change that, they need only override battle.end() and change
		the order of the 4 procs it calls.

	added turn_side.run variable.  FALSE by default.

	changed battle.is_over() - now checks to see if either side's run variable is TRUE - if so, return a winner.
*/