var
	const
		CLICK = 1
		KEY   = 2


battle_hud
	parent_type = /HudGroup
	layer = FLY_LAYER

	var
		list/parent_list = list()
		list/selections
		selection_type = KEY
		selection_key = "return"
		scroll = TRUE
		mob/owner

		highlight_color = "blue"
		default_color = "black"

		slots = 4
		columns = 2
		position = 1
	New(mob/m, list/l = list(), hc = "blue", dc="black")
		if(!m) del src
		if(!m.client) del src

		clients += m.client
		owner = m
		highlight_color = hc
		default_color = dc
		selections = new/list(slots)

		update_selections(l)

		show()
	Del()
		for(var/o in objects)
			remove(o)
		hide()
		..()
	proc
		update_selections(list/l = list(), pos = 1)
			if(l.len)
				var/hud_selection/s
				for(var/i = 1 to l.len)
					var/item = l[i]

					s = new(owner, item, highlight_color, default_color, selection_type, src)
					l[i] = s
				parent_list = l.Copy()
				for(var/i = 1 to selections.len)
					if(i <= l.len)
						s = l[i]
						selections[i] = s

			position = pos
			update()

		up()

			if(position - columns < 1)
				var/p = parent_list.Find(selections[1])
				var/list/items_before = parent_list.Copy(1, p)
				// If selections[1] is not the first item in the list, scroll up
				if(p > 1)
					var/new_start = p - items_before.len
					// If there are enough left to fill a column, move everything down one
					// otherwise move everything over one
					if(p >= columns)
						new_start = p-columns
					selections.Cut()
					for(var/i = new_start to new_start+(slots-1))
						selections += parent_list[i]
					if(position + columns < slots)
						position += columns
			else
				if(position-columns > 0)
					position -= columns

			update()

		down()
			if(position + columns > slots)
				var/p = parent_list.Find(selections[1])
				var/end = p + (slots-1)
				var/items_left = 0
				if(parent_list.len > end)
					var/list/left = parent_list.Copy(p+(slots-1))
					items_left = left.len

				// If there is more to the list than what you can see, move everything up
				if(items_left)
					var/new_start = p + items_left
					if(items_left > columns)
						new_start = p+columns

					selections.Cut()

					for(var/i = new_start to new_start+(slots-1))
						if(parent_list.len < i) break
						selections += parent_list[i]
					if(position - columns > 1)
						position -= columns
			else
				if(position+columns <= selections.len)
					position += columns

			update()

		left()
			var/left_positions = list()
			for(var/i = 1, i<=slots, i += columns)
				left_positions += i
			if(position in left_positions)
				return
			if(position-1 <= selections.len)
				position -= 1
			update()

		right()
			var/right_positions = list()
			for(var/i = columns, i<=slots, i += columns)
				right_positions += i
			if(position in right_positions)
				return
			if(position+1 <= selections.len)
				position += 1
			update()

		update()
			for(var/v in objects)
				remove(v)
			set_screen_locs()

			for(var/hud_selection/s in selections)
				add(s)
				if(selections.Find(s) == position)
					s.hover()
				else
					s.leave()

		set_screen_locs()
			if(!selections || !selections.len)
				return
			for(var/i = 1 to selections.len)
				var/hud_selection/s = selections[i]
				if(!istype(s))
					continue
				var/row = i/columns
				if(round(row) < row) row = round(row+1)
				var/cur_column = i
				while(cur_column > columns)
					cur_column -= columns

				s.screen_loc = get_screen_loc(row, cur_column)

		get_screen_loc(row, column)
			return "NORTH-[row],WEST+[column]"

		select()
			var/hud_selection/s = selections[position]
			if(s && istype(s))
				s.selected()

hud_selection
	parent_type = /HudObject
	layer = FLY_LAYER+0.1

	var
		selection_type = CLICK
		highlight_color = "blue"
		default_color = "black"
		screen_text
		mob/owner
		battle_hud/parent
		skill/skill

	New(mob/m, text, high_color = "blue", def_color = "black", sel_type = CLICK, battle_hud/b)
		if(!m) del src
		if(!b) del src
		..()
		owner = m
		parent = b
		if(istype(text, /skill))
			skill = text
			text = skill.name
		screen_text = text
		highlight_color = high_color
		default_color = def_color
		selection_type = sel_type

		maptext = "<font color=[default_color]>[screen_text]</font>"

	proc
		selected()
			if(skill)
				skill.use()
			else
				owner.battle_hud_selected(src)
		hover()
			src.maptext = "<font color=[highlight_color]>[screen_text]</font>"
		leave()
			src.maptext = "<font color=[default_color]>[screen_text]</font>"

	Click()
		if(selection_type & CLICK)
			parent.position = parent.selections.Find(src)
			parent.update()
			parent.select()

	MouseEntered()
		if(selection_type & CLICK)
			parent.position = parent.selections.Find(src)
			parent.update()
	MouseExited()
		if(selection_type & CLICK)
			parent.position = parent.selections.Find(src)
			parent.update()